;
;	Vltozk cmkiosztsa az SDC-hez
;

;
; Konstansok
;

;
; Grafikus tblzatok cmzse
;
#define	IY_GRMODE	(IY+0)		; grafikus md: bit0: 0-> 2-szn  1-> 4-szn    bit5: 1 -> kt paneles
#define	IY_PAL0		(IY+1)		; paletta kdok: 0. szn
#define	IY_PAL1		(IY+2)		; 1. szn
#define	IY_PAL2		(IY+3)		; 2. szn
#define	IY_PAL3		(IY+4)		; 3. szn
#define	IY_HEADLN	(IY+5)		; az oszlopfejlcek sora
#define	IY_FSTLN	(IY+6)		; az els bejegyzst tartalmaz sor a kpernyn
#define	IY_LSTLN	(IY+7)		; az utols bejegyzs sora
#define	IY_SUMLN	(IY+8)		; a legals sszegz sor
#define	IY_NAMECL	(IY+9)		; a nv oszlop karakteres X pozcija
#define	IY_PNUMCL	(IY+10)		; panelsorszm karakteres X pozcija
#define	IY_PATHLEN	(IY+11)		; kirhat utvonalnv-hossz karakterben
#define	IY_NCLMS	(IY+12)		; kirand oszlopok szma (nv, kit, mret)
#define	IY_MAXLN	(IY+13)		; maximlisan kirhat sorok szma
#define	IY_SCLNS	(IY+14)		; scroll-ozsnl msoland TV sorok szma
#define	IY_SELSTART	(IY+15)		; kivlasztott sor invertlsnak kezdete
#define	IY_SELCH	(IY+16)		; kivlasztott sor invertlt bjtjainak szma
#define	IY_INVSTART	(IY+17)		; teljes sor invertlsnak kezdete bjtban
#define	IY_INVFULL	(IY+18)		; invertland teljes sor hossza bjtban
#define	IY_PAPER	(IY+19)		; httr szn az tvonal s zenet sorhoz
#define	IY_INK		(IY+20)		; bet szn az tvonal s zenet sorhoz
#define	IY_CLRFILL	(IY+21)		; kitlt bjt az tvonal s zenet sor trlshez

#define INFO_LN		24

#define SDC_MAX_PATH	67

#define VID_PAGE_CFG	090h		; vidememria belapozsi rtke (U0, U1, VID, U3)


fst_ln		.equ	4		; 4-szn mdban az els bejegyzst tartalmaz sor a kpernyn
lst_ln		.equ	21		; 4-szn mdban az utols bejegyzs sora

COL_NEV		.equ	1		; nv oszlop relatv X koordintja
COL_KIT		.equ	9		; kiterjeszts
COL_MERET	.equ	17		; fjlmret
COL_DATUM	.equ	30		; dtum
COL_ATTR	.equ	43		; attribtum

SORT_NEV	.equ	1		; rendezs nv szerint
SORT_KIT	.equ	2		; rendezs kiterjeszts szerint
SORT_MERET	.equ	3		; rendezs fjlmret szerint
SORT_DATUM	.equ	4		; rendezs dtum szerint
SORT_ATTR	.equ	5		; rendezs attribtum szerint

tvfst_ln	.equ	2		; szvegnz els megjelentsre hasznlt sora
tvlst_ln	.equ	24		; szvegnz utols megjelentsre hasznlt sora
tv_nlines	.equ	tvlst_ln -tvfst_ln +1	; a kpernyn megjelenthet sorok szma
tvfullscr	.equ	(tv_nlines) * 8		; egy kpernyn megjelenthet adatbjtok szma
tv_linlen	.equ	9+(4*8)+2	; HEXA mdban az egy sorba kirt karakterek szma
tv_tmaxlen	.equ	252		; TEXT mdban a maximlis kezelhet sorhossz (4 * 63 karakter)


;
; Vltozk a platformfgg memriaterleten
;

#ifdef IFCARD
  #define  fk_RAMstart	0D000h		; segdprogramok RAM memrijnak kezdete interface krtyn
  #define  fk_RAMend	0DFF8h		; RAM memria (virtulis)vge (8 bjt levonva a 20-szal oszthatsg miatt)
#endif

#ifdef CARTRIDGE
  #define  fk_RAMstart	0F000h		; segdprogramok RAM memrijnak kezdete cartridge-nl
  #define  fk_RAMend	0FC00h		; RAM memria vge
#endif

  #define  fk_RAMstart	SDC_DATAMEM	; segdprogramok RAM memrijnak kezdete felhasznli programban
  #define  fk_RAMend	SDC_DATAEND	; RAM memria vge (gy, hogy "nbj_max" ne legyen nagyobb 255-nl)

;
; Kzsen hasznlhat vltozk a partci-kezelvel
;
bcdMSB		.equ	fk_RAMstart	; BCD alak szm trolshoz a BIN->ASCII konverzinl (5 bjt)
bcdLSB		.equ	fk_RAMstart+4
numbuff_L	.equ	fk_RAMstart+5	; szmbuffer BIN->BCD konverzhoz, als sz (2 bjt)
numbuff_H	.equ	fk_RAMstart+7	; szmbuffer BIN->BCD konverzhoz, fels sz (2 bjt)
origvmode	.equ	fk_RAMstart+9	; a programba val belpskori videmd (1 bjt)
;
; Az albbi vltozkat a partci-kezel nem rja fell, de nem is hasznlja
;
sdcvmode	.equ	fk_RAMstart+10	; SDC-ben belltott videmd (1 bjt)
akt_panel	.equ	fk_RAMstart+11	; az aktulis panel indexe (1 bjt)
;
; 1. panel paramterei
;
sorttype_1	.equ	fk_RAMstart+12	; rendezs szempontja (nv, kit. stb.) (1 bjt)
path_ptr_1	.equ	fk_RAMstart+13	; az aktulis tvonalnv mutatja (2 bjt)
fnamebuff_1	.equ	fk_RAMstart+15	; az aktulis 8.3-as fjlnv + lezr nulla (13 bjt)
;
; 2. panel paramterei
;
sorttype_2	.equ	fk_RAMstart+28	; rendezs szempontja (nv, kit. stb.) (1 bjt)
path_ptr_2	.equ	fk_RAMstart+29	; az aktulis tvonalnv mutatja (2 bjt)
fnamebuff_2	.equ	fk_RAMstart+31	; az aktulis 8.3-as fjlnv + lezr nulla (13 bjt)
;

common_end	.equ	fk_RAMstart+44


;
; SDC vltozi
;
SDCstart	.equ	fk_RAMstart+44
;
akt_ln		.equ	SDCstart	; az aktulisan kijellt sor szma (1 bjt)
akt_bj		.equ	SDCstart+1	; a tallt fjlnevek aktulis pointere (2 bjt)
xaktbj		.equ	SDCstart+3	; az aktulis fjlnv indexe (max. 255!) (1 bjt)
nbj		.equ	SDCstart+4	; a tallt bejegyzsek szma (1 bjt)
nfiles		.equ	SDCstart+5	; a tallt fjlnevek szma (1 bjt)
dircap		.equ	SDCstart+6	; az aktulis knyvtrban lv fjlok sszmrete (4 bjt)
retry_cnt	.equ	SDCstart+10	; jraprblkozsok szma (1 bjt)
dest_ptr	.equ	SDCstart+11	; a cl tvonalnv mutatja (2 bjt)
nselect		.equ	SDCstart+13	; kivlasztott fjlnevek szma (1 bjt)
selcap		.equ	SDCstart+14	; a kivlasztott fjlok sszmrete (4 bjt)
fmanid		.equ	SDCstart+18	; az aktulis fjlmanipulcis funkci kdja (0..4) (1 bjt)
rec_level	.equ	SDCstart+19	; az aktulis rekurzis mlysg (a fjlnv kijelzshez) (1 bjt)
namecl_offs	.equ	SDCstart+20	; eltolsi rtk 2 paneles megjelentshez (0 v. 32) (1 bjt)
sorttype	.equ	SDCstart+21	; rendezs szempontja (nv, kit. stb.) (1 bjt)
path_ptr	.equ	SDCstart+22	; az aktulis tvonalnv mutatja (2 bjt)
;
SDCvars_end	.equ	SDCstart+24

;
; Platform fggen elhelyezked vltozk
; (IFCARD vagy CARTRIDGE md esetn az U0 RAM-ban, a CLI adatterletn)
;
#define		strbuff	SDCstart+24	; kirsi string buffer (max. 127 karakter)

dptrbuff	.equ	strbuff  + 127	; adatmutat szvegmegjelentskor (4 bjt)
FCB_0		.equ	dptrbuff + 4	; az FCB-k azonosak a CLI ltal hasznltakkal
FCB_1		.equ	FCB_0 + 030h
FCB_2		.equ	FCB_1 + 030h
FCB_3		.equ	FCB_2 + 030h
FCB_4		.equ	FCB_3 + 030h

FPB		.equ	FCB_4 + 030h	; SDC_LIBRARY mdban FPB IX,HL,DE,BC rtknek trolshoz (8 bjt)

;
; A fjlnz vltozi (tfedsben FCB4-el)
;
scrptr		.equ	FCB_4		; kperny tetejn kijelzett adat kezdcme a fjlban (4 bjt)
ln_dsply	.equ	scrptr + 4	; megjelenthet sorhossz 62-> nincs sortrs 255-> sortrs (1 bjt)
linlenbuff	.equ	scrptr + 5	; kpernysorokban lv karakterek szmt tartalmaz tmb (23 bjt)
dbufflen	.equ	scrptr + 28	; a CLI pufferbe olvasott bjtok szma (2 bjt)

;
; Tmbvltozk
;
#define		buffstart	FPB + 008h

;
fnamepre	.equ	buffstart	; fjlnv eltti karakter (pl. alknyvtrat jelz '\') (1 bjt)
fnamebuff	.equ	buffstart+1	; 8.3-as fjlnv + lezr nulla (14 bjt)
;
pathbuff1	.equ	buffstart+15	        ; knyvtrtvonal #1 (fjlnv nlkl) (67 bjt)
pathbuff2	.equ	pathbuff1+SDC_MAX_PATH	; knyvtrtvonal #2 (fjlnv nlkl) (68 bjt)
;
sortbuff	.equ	(((pathbuff2+SDC_MAX_PATH)+1) & ~1)	; rendezett knyvtrbejegyzs-cmeket tartalmaz buffer (nbj_max  * 2 bjt)


;
; fjlnevek maximlis szma a teljes htralv RAM terletbl szmolva
;
nbj_max		.equ	(fk_RAMend - sortbuff) / 22	; 20 + 2 bjt / bejegyzs
;
nevtbl		.equ	sortbuff + (2 * nbj_max)	; az aktulis knyvtr bejegyzsei 20 bjtos struktrkban (nbj_max * 20 bjt)

;
#if (nbj_max > 255)
	.echo "\r\n*** Hiba: nbj_max nagyobb 255-nel!!! ***\r\n"
	.echo "SDC_DATAEND-et csokkenteni kell!\r\n\r\n"
#else
	.echo "\r\nAz SDC altal egy konyvtarban kezelheto fajlok maximalis szama: "
	.echo nbj_max
	.echo "\r\n\r\n"
#endif

.end
